{
  ͻ                   
   OpenSource Library                    
  ͼ                   
   Author : Vitaly Checkryzhev (Virtualik) 
   E-Mail : virty1k@mail.ru                
   WWW    : http://www.str.ru/~virty       
   WWW    : http://virtualsoft.narod.ru    
   WWW    : http://chat.str.ru             
                                           
  VIRtUal Soft         All rights reserved 
 
  
}
{
 [*] ⠢ ᠭ  童   ६, 
     ⥯ 童  ᨢ 樥⮢.
 [*] ।ᬮ ⮤  ᫥ 祭 童   㬥
 [*]  "+" 童  祭  ꥪ - 童
 [*]  "*" 童  祭  ꥪ - 童
 [*]  (뢮  ࠭) ᠭ 童
}

uses crt;

type
 { . ᨢ }
 PArray = ^TArray;
 TArray = Array [1..1] of LongInt;

 TEquation = object
 private
  NumIt: Word;   { ⢮ 童 }
  Koeff: PArray; { ᨢ 樥⮢ }
 public
  constructor Init;                        {  }
  destructor Done;                         {  ꥪ }
  function GetPower: Word;                 { 祭 ⥯ 童 }
  function GetKoeff(Index: Word): LongInt; { 祭 . 童 }
  function EqVal(X: LongInt): LongInt;     { ᫥ 祭 童 }
  procedure SetKoeff(Value: LongInt; Index: Word); { ⠭ . 童 }
  procedure SetPower(NewPower: Word);      { ⠭ ⥯ 童 }
  procedure PrintEquation;                 { 뢮  ࠭ 童 }
 end;

{ 롮 ᨬ쭮 ᫠ }
function Max(C1, C2: Word): Word;
begin
 if C1>C2 then Max := C1 else Max := C2;
end;

{  童 }
procedure SumEquations(E1, E2: TEquation; var E3: TEquation);
var
 I: Word;
begin
 E3.Init;
 E3.SetPower(Max(E1.GetPower, E2.GetPower));
 For I := 1 to E3.GetPower + 1 do
  begin
   if I<=E1.GetPower+1 then { ᥭ   1- 童 }
    E3.SetKoeff(E3.GetKoeff(I + E3.GetPower - E1.GetPower) + E1.GetKoeff(I), I + E3.GetPower - E1.GetPower);

   if I<=E2.GetPower+1 then { ᥭ   1- 童 }
    E3.SetKoeff(E3.GetKoeff(I + E3.GetPower - E2.GetPower) + E2.GetKoeff(I), I + E3.GetPower - E2.GetPower);
  end;
end;

{  童 }
procedure MultEquations(E1, E2: TEquation; var E3: TEquation);
var
 I, I2: Word;
begin
 E3.Init;
 E3.SetPower(E1.GetPower + E2.GetPower); 

 For I := 1 to E1.GetPower+1 do
  For I2 := 1 to E2.GetPower+1 do
   { ६ 童 }
   E3.SetKoeff(E3.GetKoeff(I+I2-1) + E1.GetKoeff(I) * E2.GetKoeff(I2), I+I2-1);
end;

{  X  ⥯ I.
  ஢   Math  Delphi }
function RaisePower(X, I: LongInt): Real;
var
  Y: LongInt;
  Result : Real;
begin
 Y := Abs(I);
 Result := 1;
 while Y > 0 do
 begin
  while not Odd(Y) do
   begin
    Y := Y shr 1;
    X := X * X
   end;
  Dec(Y);
  Result := Result * X
 end;
 if I < 0 then RaisePower := 1/Result else RaisePower := Result;
end;

{ TEquation }

constructor TEquation.Init;
begin
 New(Koeff); { 뤥   ᨢ }
 NumIt := 0;
end;

destructor TEquation.Done;
begin
 NumIt := 0;
 Dispose(Koeff);
end;

function TEquation.GetPower: Word;
begin
 GetPower := NumIt - 1;
end;

procedure TEquation.SetPower(NewPower: Word);
begin
 NumIt := NewPower + 1; {  ᫮ 童 }
 FillChar(Koeff^, SizeOf(LongInt)*NumIt, 0); {  ᨢ ﬨ }
end;

procedure TEquation.SetKoeff(Value: LongInt; Index: Word);
begin
 Koeff^[Index] := Value;
end;

function TEquation.GetKoeff(Index: Word): LongInt;
begin
 GetKoeff := Koeff^[Index];
end;

procedure TEquation.PrintEquation;
var
 I: Word;
begin
 For I := 1 to NumIt do
 begin
  if Koeff^[I]<0 then { ᫨ . ⥫ }
    begin
     Write(' - ');
     If Abs(Koeff^[I])<>1 then Write(Abs(Koeff^[I]));
    end else

    if Koeff^[I]>0 then { ᫨ . ⥫ }
    begin
     if I>1 then Write(' + '); {   +, ᫨ ⥪騩 童   }
      if I<>NumIt then
      begin
       If Koeff^[I]<>1 then Write(Koeff^[I]);
      end else Write(Koeff^[I]);
    end;

    { 뢮  ६  ⥯ }
    if (NumIt-I>0) and (Koeff^[I]<>0) then
    begin
     Write('x');
     if NumIt-I>1 then Write('^', NumIt - I);
    end;
  end;
end;

function TEquation.EqVal(X: LongInt): LongInt;
var
 I: Word;
 R: LongInt;
begin
 R := 0;
 for I := 1 to NumIt do
  {  祭 ᫥ 童 童 }
  R := R + Koeff^[I] * Round(RaisePower(X, NumIt - I));
 EqVal := R;
end;

var
 E1, E2, Res: TEquation;

begin
 ClrScr;
 { 뢠 樥 }
 E1.Init;
 E1.SetPower(1);
 E1.SetKoeff(2, 1);
 E1.SetKoeff(3, 2);

 E2.Init;
 E2.SetPower(2);
 E2.SetKoeff(3, 1);
 E2.SetKoeff(2, 2);
 E2.SetKoeff(6, 3);

 { 㬬 }
 Write('F1(x) = ');
 E1.PrintEquation;
 Writeln;

 Write('F2(x) = ');
 E2.PrintEquation;
 Writeln;

 SumEquations(E1, E2, Res);
 Write('F1(x)+F2(x) = ');
 Res.PrintEquation;
 Writeln;

 {  }
 MultEquations(E1, E2, Res);
 Write('F1(x)*F2(x) = ');
 Res.PrintEquation;
 Writeln;

 { 襭 ࠡ, 㤠 ꥪ⮢ }
 E1.Done;
 E2.Done;
 Res.Done;
end.